#ifndef CITY_H_
#define CITY_H_

#include <iostream>
#include <string>

#include "Coordinate.h"

using namespace std;

/**
 * City data.
 */
class City
{
public:
    /**
     * Default constructor.
     */
    City();

    /**
     * Destructor.
     */
    ~City();

    /**
     * Getter.
     * @return the city's name.
     */
    string get_name() const;

    /**
     * Getter.
     * @return the city's state.
     */
    string get_state() const;

    /**
     * Getter.
     * @return the city's coordinate.
     */
    Coordinate get_coordinate() const;

    /**
     * Overloaded input stream operator to read a city
     * from an input stream.
     * @param ins the input stream.
     * @param city the city to read.
     * @return the input stream.
     */
    friend istream& operator >>(istream& ins, City& city);

    /**
     * Overloaded output stream operator to output a city
     * to an output stream.
     * @param outs the output stream.
     * @param city the city to output.
     * @return the output stream.
     */
    friend ostream& operator <<(ostream& outs, const City& city);

private:
    string name;
    string state;
    Coordinate coordinate;
};

#endif /* CITY_H_ */
